/// <reference types="react" />
import React from "react";
declare namespace SrLayout {
    interface SrLayoutOptions {
        domains?: string[];
        disabledAutoJump?: boolean;
        reject?: (path: string) => void;
        init?: Function;
        whiteList?: string[];
        getInitData(): Promise<any>;
    }
    interface SrLayoutMenuItem {
        name: string;
        id: number;
        children?: SrLayoutMenuItem[];
        icon?: string;
        iconSelect?: string;
        pid: number;
        parent?: SrLayoutMenuItem;
        type: number;
        url?: string;
        code?: string;
    }
    interface IUserInfo {
        authStatus: boolean;
        checkStatus: number;
        checkTime: null;
        companyId: number;
        companyName: string;
        createTime: string;
        dingUserId: string;
        id: number;
        mail: null | string;
        name: string;
        realName: string;
    }
    interface IPlatform {
        createTime: string;
        createUserName: string;
        icon: string;
        id: number;
        mark: string;
        name: string;
        principalName: string;
        qaUrl: string;
        url: string;
    }
    interface LayoutRoute {
        path: string;
        exact?: boolean;
        component: (() => JSX.Element) | Promise<any>;
        children?: LayoutRoute[];
    }
    function Router(props: {
        routes: LayoutRoute[];
    }): JSX.Element;
    const LayoutCtx: React.Context<{
        tree: SrLayoutMenuItem[];
        list: SrLayoutMenuItem[];
        userInfo: IUserInfo;
        platform: IPlatform;
        whiteList: string[];
        access: (params: {
            action: string;
        }) => boolean;
    }>;
    const useLayout: (options: SrLayoutOptions) => {
        LayoutState: {
            tree: SrLayoutMenuItem[];
            list: SrLayoutMenuItem[];
            userInfo: IUserInfo;
            platform: IPlatform;
            whiteList: string[];
            access: (params: {
                action: string;
            }) => boolean;
        };
        LayoutCtx: React.Context<{
            tree: SrLayoutMenuItem[];
            list: SrLayoutMenuItem[];
            userInfo: IUserInfo;
            platform: IPlatform;
            whiteList: string[];
            access: (params: {
                action: string;
            }) => boolean;
        }>;
    };
    function Layout(props: {
        children: JSX.Element;
        headslot?: JSX.Element;
        reject?: (path: string) => void;
    }): JSX.Element;
    function Access(props: {
        action: string;
        children: ((params: {
            allow: boolean;
        }) => any) | JSX.Element;
    }): any;
}
export { SrLayout };
