import { jsxs, jsx, Fragment } from 'react/jsx-runtime';
import React, { useState, useContext, useEffect } from 'react';
import { Menu } from 'antd';
import { useHistory, useLocation, Switch, Route } from 'react-router-dom';
import { MenuUnfoldOutlined, MenuFoldOutlined } from '@ant-design/icons';
import loadable from '@loadable/component';
import { TransitionGroup, CSSTransition } from 'react-transition-group';

function styleInject(css, ref) {
    if (ref === void 0)
        ref = {};
    var insertAt = ref.insertAt;
    if (!css || typeof document === 'undefined') {
        return;
    }
    var head = document.head || document.getElementsByTagName('head')[0];
    var style = document.createElement('style');
    style.type = 'text/css';
    if (insertAt === 'top') {
        if (head.firstChild) {
            head.insertBefore(style, head.firstChild);
        }
        else {
            head.appendChild(style);
        }
    }
    else {
        head.appendChild(style);
    }
    if (style.styleSheet) {
        style.styleSheet.cssText = css;
    }
    else {
        style.appendChild(document.createTextNode(css));
    }
}

var css_248z = ".layout-container {\n  position: relative;\n  height: 100vh;\n  background: #f0f2f5;\n  display: flex; }\n\n.lv3-side-menu {\n  width: 208px;\n  height: 100%;\n  box-shadow: 2px 0 8px 0 rgba(29, 35, 41, 0.05);\n  z-index: 10;\n  background-color: #001529;\n  transition: all 0.3s;\n  overflow-x: hidden; }\n  .lv3-side-menu.pickup {\n    width: 50px; }\n    .lv3-side-menu.pickup .lv3-top-app {\n      padding-left: 9px; }\n  .lv3-side-menu .ant-menu-inline-collapsed {\n    width: 50px !important; }\n\n.lv3-top-app {\n  height: 64px;\n  padding-left: 24px;\n  display: flex;\n  align-items: center;\n  background: #001529; }\n\n.lv3-top-icon {\n  width: 32px;\n  height: 32px; }\n\n.lv3-top-name {\n  font-size: 18px;\n  color: white;\n  font-weight: 500;\n  margin-left: 12px;\n  width: 100%;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  -webkit-line-clamp: 1; }\n\n.lv3-side-menu-box {\n  height: calc(100% - 112px);\n  overflow: auto; }\n  .lv3-side-menu-box .ant-menu-item, .lv3-side-menu-box .ant-menu-submenu-title {\n    display: flex;\n    align-items: center; }\n\n.lv3-layout {\n  display: flex;\n  flex: 1;\n  flex-direction: column;\n  min-height: 0;\n  background: #f0f2f5;\n  overflow-x: hidden; }\n  .lv3-layout-header {\n    height: 48px;\n    line-height: 48px;\n    box-shadow: 0 1px 4px rgba(0, 21, 41, 0.08);\n    background: white;\n    box-sizing: border-box;\n    padding: 0 16px;\n    display: flex;\n    align-items: center;\n    justify-content: space-between; }\n    .lv3-layout-header-items {\n      display: flex;\n      align-items: center; }\n    .lv3-layout-header-icon {\n      padding: 0 12px;\n      cursor: pointer;\n      transition: .2s;\n      font-size: 16px;\n      display: flex;\n      align-items: center;\n      height: 48px; }\n      .lv3-layout-header-icon:hover {\n        background-color: #F9F9F9; }\n    .lv3-layout-header-avatar {\n      width: 24px;\n      height: 24px;\n      margin-right: 8px; }\n      .lv3-layout-header-avatar img {\n        width: 100%;\n        height: 100%;\n        display: block; }\n    .lv3-layout-header-name {\n      color: rgba(0, 0, 0, 0.85);\n      font-size: 14px; }\n\n.lv3-layout-intro {\n  color: rgba(0, 0, 0, 0.45);\n  font-size: 14px;\n  text-align: center;\n  padding: 20px 0; }\n\n.lv3-layout-content {\n  box-sizing: border-box;\n  height: calc(100vh - 48px);\n  overflow-y: auto;\n  padding: 16px; }\n\n.lv3-side-menu.unfold .ant-menu-submenu-title > span, .lv3-side-menu.unfold .ant-menu-item > span {\n  letter-spacing: 2px;\n  display: inline-block;\n  width: 15px;\n  overflow: hidden; }\n\n.lv3-menu-icon {\n  width: 20px;\n  height: 20px;\n  margin-right: 10px; }\n\n.lv3-fade-enter {\n  opacity: 0;\n  z-index: 1; }\n\n.lv3-fade-enter-active {\n  opacity: 1;\n  transition: opacity .25s ease-in; }\n\n.lv3-fade-exit {\n  display: none; }\n\n.lv3-side-collapse {\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  height: 48px;\n  font-size: 16px; }\n  .lv3-side-collapse.collapse {\n    padding: 0 20px;\n    justify-content: flex-end; }\n  .lv3-side-collapse > span {\n    color: rgba(255, 255, 255, 0.65);\n    transition: .2s; }\n    .lv3-side-collapse > span:hover {\n      color: white;\n      cursor: pointer; }\n";
styleInject(css_248z);

const SrLayoutItemIdMap = new Map();
const SrLayoutItemPathMap = new Map();
const composeTree = (list) => {
    const map = new Map();
    for (let l of list) {
        map.set(l.id, l);
        SrLayoutItemIdMap.set(String(l.id), l);
        if (l.url)
            SrLayoutItemPathMap.set(l.url, l);
    }
    let tree = [];
    for (let ctx of map) {
        const item = ctx[1];
        if (item.pid === 0) {
            tree.push(item);
        }
        else {
            const parent = map.get(item.pid);
            if (parent) {
                item.parent = parent;
                parent.children = parent.children || [];
                parent.children.push(item);
            }
        }
    }
    return tree;
};
const ObjectOmit = (obj, keys) => {
    let newObj = {};
    return Object.keys(obj).reduce((a, b) => {
        if (!keys.includes(b))
            newObj[b] = obj[b];
        return newObj;
    }, newObj);
};
const fetch = (url) => {
    return new Promise((resolve, reject) => {
        const xhr = new XMLHttpRequest();
        xhr.withCredentials = true;
        xhr.open('GET', url);
        xhr.send();
        xhr.onload = resolve;
        xhr.onerror = reject;
    });
};
const setCookies = async (domains) => {
    const ticket = window.location.href.match(/ticket=([\w\d]+)&?/);
    if (ticket) {
        for (let d of domains) {
            await fetch(d + '/v1/auth/resource?ticket=' + ticket[1]);
        }
        console.log('href', window.location.href.replace(/ticket=([\w\d]+)&?\??/, ''));
        window.location.replace(window.location.href.replace(/ticket=([\w\d]+)&?\??/, ''));
        if (window.location.hash) {
            window.location.reload();
        }
    }
};

function LayoutSideBar(props) {
    const [collapse, setCollapse] = useState(false);
    const [selectKeys, setSelectKeys] = useState([]);
    const [openKeys, setOpenKeys] = useState([]);
    const [init, setInit] = useState(false);
    const ctx = useContext(LayoutCtx);
    const history = useHistory();
    const location = useLocation();
    useEffect(() => {
        let current = SrLayoutItemPathMap.get(location.pathname);
        if (current) {
            while (current) {
                if (current.type <= 2)
                    break;
                current = current.parent;
            }
            if (current && current.type === 2) {
                setSelectKeys([String(current.id)]);
                if (!init) {
                    let openKeys = [];
                    while (current.parent && current.parent.type === 2) {
                        openKeys.push(String(current.parent.id));
                        current = current.parent;
                    }
                    setOpenKeys(openKeys);
                    setInit(true);
                }
            }
        }
    }, [location, init]);
    return (jsxs("div", Object.assign({ className: `lv3-side-menu ${collapse ? 'pickup' : ''}` }, { children: [jsxs("div", Object.assign({ className: "lv3-top-app" }, { children: [jsx("img", { src: ctx.platform.icon, alt: "", className: "lv3-top-icon" }, void 0),
                    !collapse &&
                        jsx("span", Object.assign({ className: "lv3-top-name" }, { children: ctx.platform.name }), void 0)] }), void 0),
            jsx("div", Object.assign({ className: "lv3-side-menu-box" }, { children: props.currentModule &&
                    jsx(Menu, Object.assign({ mode: "inline", theme: "dark", selectedKeys: selectKeys, inlineCollapsed: collapse, inlineIndent: 12, onClick: item => {
                            const current = SrLayoutItemIdMap.get(String(item.key));
                            if (current && current.url)
                                history.push(current.url);
                        }, onOpenChange: (keys) => {
                            setOpenKeys(keys.map(k => k.toString()));
                        }, openKeys: openKeys }, { children: props.currentModule.children.filter(t => t.type === 2).map(t => jsx(SideMenuRender, { menu: t }, t.id)) }), void 0) }), void 0),
            jsx("div", Object.assign({ className: `lv3-side-collapse ${!collapse ? 'collapse' : ''}` }, { children: collapse ?
                    jsx(MenuUnfoldOutlined, { onClick: () => setCollapse(!collapse) }, void 0) :
                    jsx(MenuFoldOutlined, { onClick: () => setCollapse(!collapse) }, void 0) }), void 0)] }), void 0));
}
function SideMenuRender(props) {
    const menu = props.menu;
    const p = ObjectOmit(props, ['menu']);
    if (menu.children && menu.children.filter(c => c.type === 2).length) {
        return (jsx(Fragment, { children: jsx(Menu.SubMenu, Object.assign({ title: menu.name }, p, { children: menu.children.filter(c => c.type === 2).map(c => jsx(SideMenuRender, { menu: c }, c.id)) }), String(menu.id)) }, void 0));
    }
    else {
        return (jsx(Menu.Item, Object.assign({}, p, { children: menu.name }), String(menu.id)));
    }
}

function SrLayoutHeader(props) {
    const [selectKeys, setSelectKeys] = useState([]);
    const [openKeys, setOpenKeys] = useState([]);
    useEffect(() => {
        if (props.currentModule)
            setSelectKeys([String(props.currentModule.id)]);
    }, [props.currentModule]);
    return (jsxs("header", Object.assign({ className: "lv3-layout-header" }, { children: [jsx("div", Object.assign({ className: "lv3-layout-header-menus" }, { children: jsx(Menu, Object.assign({ selectedKeys: selectKeys, onClick: item => {
                        setSelectKeys([String(item.key)]);
                        props.setSelectMenu(SrLayoutItemIdMap.get(String(item.key)));
                    }, onOpenChange: (keys) => {
                        setOpenKeys(keys.map(k => k.toString()));
                    }, openKeys: openKeys, mode: 'horizontal' }, { children: props.tree.filter(t => t.type === 1).map(t => jsx(HeaderMenu, { item: t }, t.id)) }), void 0) }), void 0),
            jsx("div", Object.assign({ className: "lv3-layout-header-items" }, { children: props.children }), void 0)] }), void 0));
}
function HeaderMenu(props) {
    const menu = props.item;
    const p = ObjectOmit(props, ['menu']);
    if (menu.children && menu.children.filter(c => c.type === 1).length) {
        return (jsx(Fragment, { children: jsx(Menu.SubMenu, Object.assign({ title: menu.name }, p, { children: menu.children.filter(c => c.type === 1).map(c => jsx(HeaderMenu, { item: c }, c.id)) }), String(menu.id)) }, void 0));
    }
    else {
        return (jsx(Menu.Item, Object.assign({}, p, { children: menu.name }), String(menu.id)));
    }
}

function Router(props) {
    return (jsx(RenderRoute, { routes: props.routes }, void 0));
}
function RenderChild(props) {
    if (!props.routes || !props.routes.length)
        return null;
    return (jsx(RenderRoute, { routes: props.routes }, void 0));
}
function RenderRoute(props) {
    const location = useLocation();
    const ctx = useContext(LayoutCtx);
    const Child = (props) => {
        const r = props.r;
        if (SrLayoutItemPathMap.get(location.pathname) || ctx.whiteList.includes(location.pathname)) {
            let Component = r.component instanceof Promise ? loadable(() => r.component) : r.component;
            return (jsxs(Fragment, { children: [jsx(Component, {}, void 0),
                    jsx(RenderChild, { routes: r.children }, void 0)] }, void 0));
        }
        else {
            return (jsx("h1", { children: "404" }, void 0));
        }
    };
    return (jsx(TransitionGroup, { children: jsx(CSSTransition, Object.assign({ timeout: 250, classNames: "lv3-fade" }, { children: jsx("section", Object.assign({ className: "lv3-section" }, { children: jsx(Switch, Object.assign({ location: location }, { children: props.routes.map((r, i) => jsx(Route, Object.assign({ exact: r.exact, path: r.path }, { children: jsx(Child, { r: r }, void 0) }), i)) }), void 0) }), void 0) }), location.key) }, void 0));
}

const checkPath = (path, setCurrentModule, whiteList, reject) => {
    const menu = SrLayoutItemPathMap.get(path);
    let module;
    let timmer = 0;
    if (menu) {
        let current = menu.parent;
        while (current) {
            if (current.type === 1) {
                module = current;
                break;
            }
            current = current.parent;
        }
    }
    else if (path !== '/' && !whiteList.includes(path)) {
        if (timmer)
            clearTimeout(timmer);
        timmer = setTimeout(() => {
            reject && reject(path);
        });
    }
    setCurrentModule(module);
};
const ctx = {
    tree: [],
    list: [],
    userInfo: {},
    platform: {},
    whiteList: [],
    access: (params) => false
};
const LayoutCtx = React.createContext(ctx);
const useLayout = (options) => {
    const [state, setState] = useState(ctx);
    let location = useLocation();
    useEffect(() => {
        const fn = async () => {
            if (options.domains && options.domains.length) {
                await setCookies(options.domains);
            }
            options.getInitData().then(res => {
                const tree = composeTree(res.permissionVoList);
                const stateData = {
                    list: res.permissionVoList,
                    tree: tree,
                    whiteList: options.whiteList || [],
                    userInfo: res.userInfo,
                    platform: res.platform,
                    access: (params) => {
                        const menu = SrLayoutItemPathMap.get(location.pathname);
                        return !!menu && menu.children.some(c => c.code === params.action);
                    }
                };
                setState(stateData);
                setTimeout(() => {
                    options.init && options.init(stateData);
                });
            });
        };
        fn();
    }, []);
    return { LayoutState: state, LayoutCtx };
};
function Layout(props) {
    const [currentModule, setCurrentModule] = useState();
    const state = useContext(LayoutCtx);
    let location = useLocation();
    useEffect(() => {
        checkPath(location.pathname, setCurrentModule, state.whiteList || [], props.reject);
    }, [location, props.children]);
    return (jsx(Fragment, { children: !!state.tree.length &&
            jsxs("section", Object.assign({ className: "layout-container" }, { children: [jsx(LayoutSideBar, { currentModule: currentModule }, void 0),
                    jsxs("div", Object.assign({ className: "lv3-layout" }, { children: [jsx(SrLayoutHeader, Object.assign({ tree: state.tree, setSelectMenu: setCurrentModule, currentModule: currentModule }, { children: props.headslot }), void 0),
                            jsx("div", Object.assign({ className: "lv3-layout-content" }, { children: props.children }), void 0)] }), void 0)] }), void 0) }, void 0));
}
function Access(props) {
    const location = useLocation();
    const menu = SrLayoutItemPathMap.get(location.pathname);
    const allow = !!menu && menu.children.some(c => c.code === props.action);
    if (typeof props.children === 'function') {
        return props.children({ allow });
    }
    else {
        if (allow)
            return props.children;
        return null;
    }
}

var index = /*#__PURE__*/Object.freeze({
  __proto__: null,
  LayoutCtx: LayoutCtx,
  useLayout: useLayout,
  Layout: Layout,
  Access: Access,
  Router: Router
});

export { index as SrLayout };
//# sourceMappingURL=main.js.map
